import { Inject, Injectable } from '@nestjs/common';
import { OnEvent } from '@nestjs/event-emitter';
import { MessagePublisherPort } from '@mobicoop/ddd-library';
import { USER_MESSAGE_PUBLISHER } from '@modules/user/user.di-tokens';
import { UserDeletedDomainEvent } from '../../domain/events/user-deleted.domain-event';

@Injectable()
export class PublishMessageWhenUserIsDeletedDomainEventHandler {
  constructor(
    @Inject(USER_MESSAGE_PUBLISHER)
    private readonly messagePublisher: MessagePublisherPort,
  ) {}

  @OnEvent(UserDeletedDomainEvent.name, { async: true, promisify: true })
  async handle(event: UserDeletedDomainEvent): Promise<any> {
    this.messagePublisher.publish('user.deleted', JSON.stringify(event));
  }
}
